Redmine - Defect #20831

journal_details table reverted value and old_value back to String on update from 2.6.0 to 3.1.1
2015-09-24 16:00 - John Janus

Status: Closed Start date:

Priority: Normal Due date:

Assignee: % Done: 0%
Category: Database Estimated time: 0.00 hour

Target version:

Resolution: Invalid Affected version: 3.1.1

Description

| recently upgraded our redmine installation from 2.6.0 to 3.1.1.
Since then it has not been possible to edit descriptions.
The log shows the following error:

Mysql2::Error: Data too long for column 'value' at row 1: INSERT INTO “journal_details™ (‘property’, "prop_key", “old_value’, ‘value’,
“journal_id") VALUES (‘attr', 'description’, '<long description here>',2068)
The same error message appears for old_value.

| found Defect #15483, which describes a similar problem.

A quick check in the database shows, that the type for old_value and value is indeed varchar(255).

BUT in the database for the 2.6.0 version, those columns had varchar(255) as type as well, though editing a description was possible
there.

Version 2.6.0 was installed without prior data on a windows server with the bitnami stack (mysql as database).
3.1.1 was installed on a linux server with mariadb 10.0.20. the database was dumped from the windows mysql server and read into
the mariadb without problems.

Related issues:

Related to Redmine - Defect #15483: Error 500 on Issue Update (postgres) Closed
Has duplicate Redmine - Defect #23741: unable to modify the issue description Closed
History

#1 - 2015-09-25 02:06 - Go MAEDA

- Status changed from New to Needs feedback

No problem with my installation of 3.1.1. journal_details table have not been changed since Redmine 1.1 (r4954).

$ grep -1 Jjournal_details db/migrate/*
db/migrate/007_create_journals.rb
db/migrate/20110227125750_change_Jjournal_details_values_to_text.rb

Could you describe detailed upgrade procedure you have done?

#2 - 2015-09-25 02:07 - Go MAEDA
- Related to Defect #15483: Error 500 on Issue Update (postgres) added

#3 - 2015-09-25 14:54 - John Janus

| installed Redmine on the Linux machine, created a dump from the database on the Windows box, put that into the new database and started
"bundle exec rake db:migrate RAILS_ENV=production"
as described at http://www.redmine.org/projects/redmine/wiki/RedmineUpgrade

It might be possible, that the initial bithami Windows install was already defective, as the type of the fields are set to varchar(255) on the Windows box
as well.

It was however never a problem to change the description on that install.

the commands i issued were:

mysgldump -h<winmachine> -u<user> -p<pass> bitnami_redmine > redminedump.sqgl
mysgl —-u<user> -p<pass> -D redmine < redminedump.sqgl
bundle exec rake db:migrate RAILS_ENV=production
https://www.redmine.org/issues/15483
https://www.redmine.org/projects/redmine/repository/svn/revisions/4954
http://www.redmine.org/projects/redmine/wiki/RedmineUpgrade

After changing the types to text, the issue is solved.

#4 - 2015-10-22 07:14 - Toshi MARUYAMA
- Status changed from Needs feedback to Closed

- Resolution set to Invalid

Thank you for your feedback.

#5 - 2016-01-04 11:00 - Anonymous
- File sqlite3-to-mysql.py added
- File dump_error.log added

Hi,

| get the same issue (full stack attached) :

Mysqgl2::Error: Data too long for column 'old_value' at row 880: ALTER TABLE " journal_details® CHANGE "old_valu
e’ “old_value' varchar (255) DEFAULT NULL/home/ges/.rvm/gems/ruby-2.2.1/gems/activerecord-4.2.5/1ib/active_reco
rd/connection_adapters/abstract_mysqgl_adapter.rb:305:in “query'

I'm upgrading from Redmine 1.x

About your application's environment
Ruby version 1.8.7 (x86_64-1inux)
RubyGems version 1.8.15

Rack version 1.3

Rails version 2.3.14

Active Record version 2.3.14

Active Resource version 2.3.14
Action Mailer version 2.3.14

Active Support version 2.3.14

Edge Rails revision unknown
Application root /usr/share/redmine
Environment production

Database adapter sglite3

Database schema version 20110902000000

To Redmine 3.x

Environment:

Redmine version 3.2.0.stable
Ruby version 2.2.1-p85 (2015-02-26) [x86_64-1linux]
Rails version 4.2.5
Environment production
Database adapter Mysqgl2

SCM:

Subversion 1.6.17

Git 1.7.10.4

Filesystem

Redmine plugins:

no plugin installed

I dump my sqlite3 and use a script to translate the dump to MySQL format (cf. attachment)

| can see in sqlite3 and MySQL dump this kind of line that is clearly larger than 255 chars :

INSERT INTO "journal_details" VALUES (1171,1055, 'attr', 'description', 'En profil documentaliste, les bordereau d
e recherche ne tient pas dans 1''écran”™M

==> nécessité d''utiliser la barre de scroll pour valider.”M

M

Demande : faire tenir la fenétre dans 1''écran.”M

', '"En profil documentaliste, les bordereaux de recherche ne tiennent pas dans 1''écran”™M

==> nécessité d''utiliser la barre de scroll pour valider.”M

M

Demande : faire tenir la fenétre dans 1''écran.”M

)i
What | don't understand, is that the column old_value is already varchar(255), but data bigger than 255 was inserted in it without problem.
#6 - 2016-01-04 14:25 - Anonymous

Well, for now, | shrinked too large values with this queries :

use redmine;

update journal_details set old_value = left (old_value, 255) where length(old_value) > 255;
update journal_details set value = left (value, 255) where length(value) > 255;

#7 - 2016-01-12 13:01 - Toshi MARUYAMA

Patrick Ferreira wrote:

What | don't understand, is that the column old_value is already varchar(255), but data bigger than 255 was inserted in it without problem.

old_value should be text, not varchar(255).

#8 - 2016-09-04 18:45 - Toshi MARUYAMA
- Related to Defect #23741: unable to modify the issue description added

#9 - 2016-09-05 14:57 - Toshi MARUYAMA
- Related to deleted (Defect #23741: unable to modify the issue description)

#10 - 2016-09-05 15:00 - Toshi MARUYAMA
- Has duplicate Defect #23741: unable to modify the issue description added

Files
sqlite3-to-mysql.py 1.08 KB 2016-01-04 Anonymous
dump_error.log 13.1 KB 2016-01-04 Anonymous
